/*
** OOP Dispatcher v1.00
**  2004 by Mario Vilas (aka QvasiModo)
** All rights reserved.
**  This package is available completely free of any charges for any person
**  to use for purposes including commercial software but the source files
**  must not be sold or included in any commercial programming package.
**  This also includes publications that are for sale.
*/

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif

typedef struct _LIBRARY

    DWORD        dwCPUID            // CPU ID supported features flags.
    char        *pszFileName        // Pointer to library filename.

} LIBRARY, *LPLIBRARY;

typedef struct _DISPATCH {

    // Fill this members before calling LoadAndDispatch.
    void        *pMethods           // Pointer to array of pointers to method names.
    int          iMethods           // Number of methods in the interface.
    LIBRARY     *pLibraries         // Pointer to array of LIBRARY structures.
    int          iLibraries         // Number of elements in the array pointed to by pLibraries.
    char        *pszDefault         // Pointer to default library filename (NULL for none).

    // This members are set on return from LoadAndDispatch.
    HINSTANCE    hLib               // Handle to library (NULL for none).
    HINSTANCE    hDefLib            // Handle to default library (NULL for none).

} DISPATCH, *LPDISPATCH;

void WINAPI InitDispatcher();
DWORD WINAPI GetFeaturesFlags();
char WINAPI *FindDispatchLibrary( DISPATCH *pDispatch );
int WINAPI LoadAndDispatch( void *pInterface, DISPATCH *pDispatch );
BOOL WINAPI UnloadDispatchLibrary( DISPATCH *pDispatch );

#ifdef __cplusplus
}
#endif
