;OOP Dispatcher v1.00 BETA
;By Mario Vilas (aka QvasiModo)
;Released into public domain.
;No warranties of any kind are given.
;Use at your own risk.

; Import header for Dispatcher.dll and Dispatcher.lib

; ----------------------------------------------------------------------------------------------------
; Variables
; ----------------------------------------------------------------------------------------------------

EXTERNDEF dwProcessorFeatures:DWORD		;Current CPU ID supported features flags.
										;Available only when linking statically.

; ----------------------------------------------------------------------------------------------------
; Structures
; ----------------------------------------------------------------------------------------------------

LIBRARY struct

	dwProcessorFeatures		DWORD ?		;CPU ID supported features flags.
	pszFileName				DWORD ?		;Pointer to library filename.

LIBRARY ends

DISPATCH struct

	; Fill this members before calling LoadAndDispatch.
	pMethods		DWORD ?			;Pointer to array of pointers to method names.
	iMethods		DWORD ?			;Number of methods in the interface.
	pLibraries		DWORD ?			;Pointer to array of LIBRARY structures.
	iLibraries		DWORD ?			;Number of elements in the array pointed to by pLibraries.
	pszDefault		DWORD ?			;Pointer to default library filename (NULL for none).

	; This members are set on return from LoadAndDispatch.
	hLib			HINSTANCE ?		;Handle to library (NULL for none).
	hDefLib			HINSTANCE ?		;Handle to default library (NULL for none).

DISPATCH ends

; ----------------------------------------------------------------------------------------------------
; Prototypes
; ----------------------------------------------------------------------------------------------------

InitDispatcher			proto
; Input:
;	Nothing.
; Output:
;	Nothing.
; Remarks:
;	Call this function before any other of this library.
;	Available only when linking statically.

GetFeaturesFlags		proto
; Input:
;	Nothing.
; Output:
;	Returns the current CPU ID value.
;	Available only when linking dynamically.

FindDispatchLibrary		proto pDispatch:PTR DISPATCH
; Input:
;	pDispatcher:	Pointer to filled DISPATCH structure. See the remarks section below.
; Output:
;	Returns a pointer to the library filename for the current CPU.
;	If no library is found, the default library filename is returned instead.
;	If no defauly library is provided either, it returns NULL.

LoadAndDispatch			proto pDispatch:PTR DISPATCH, pInterface:DWORD
; Input:
;	pDispatcher:	Pointer to filled DISPATCH structure.
;	pInterface:		Pointer to interface. It's members will be filled on return.
; Output:
;	Returns the number of methods found by the dispatcher.
; Remarks:
;	The return value may not equal iMethods.
;	This function will internally call FindDispatchLibrary.
;	If a particular method is not found, the corresponding interface structure member remains unchanged.

UnloadDispatchLibrary	proto pDispatch:PTR DISPATCH
; Input:
;	pDispatcher:	Pointer to filled DISPATCH structure.
; Output:
;	Returns TRUE on success, or FALSE on error.
; Remarks:
;	Call this function to free the libraries loaded by LoadAndDispatch.
