;1.3) FindDispatchLibrary
; Prototype:
;	char *FindDispatchLibrary( DISPATCH *pDispatch );
; Input:
;	pDispatcher:	Pointer to filled DISPATCH structure. See the remarks section below.
; Output:
;	Returns a pointer to the library filename for the current CPU.
;	If no library is found, the default library filename is returned instead.
;	If no defauly library is provided either, it returns NULL.

.code
align DWORD
FindDispatchLibrary proc uses ebx pDispatch:PTR DISPATCH

	mov ebx,pDispatch
	test ebx,ebx
	jz short badarg
	mov ecx,[ebx].DISPATCH.iLibraries
	cmp ecx,0
	jle short badarg
	mov edx,[ebx].DISPATCH.pLibraries
	test edx,edx
	jz short badarg
	.repeat
		mov eax,dwProcessorFeatures
		and eax,[edx].LIBRARY.dwProcessorFeatures
		cmp eax,[edx].LIBRARY.dwProcessorFeatures
		je short found
continue:
		add edx,sizeof LIBRARY
	.untilcxz
	mov eax,[ebx].DISPATCH.pszDefault

quit:
	ret

found:
	mov eax,[edx].LIBRARY.pszFileName
	test eax,eax
	jz short continue
	push ecx
	push edx
	invoke SearchPath,NULL,eax,NULL,0,NULL,NULL
	pop edx
	pop ecx
	test eax,eax
	jz short continue
	jmp short quit

notfound:
	push ERROR_FILE_NOT_FOUND
	jmp short seterr

badarg:
	push ERROR_BAD_ARGUMENTS

seterr:
	call SetLastError
	xor eax,eax
	jmp short quit

FindDispatchLibrary endp
